/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;



import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumRTBeamLimitingDeviceType;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;




/**
* This item class contains methods to validate,set and get the attributes in {@link BeamLimitingDeviceToleranceSequence}.
 */
public class BeamLimitingDeviceToleranceSequenceItem extends Item  
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	BeamLimitingDeviceToleranceSequenceItem()
	{
		super();
	}


	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	BeamLimitingDeviceToleranceSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates BeamLimitingDeviceToleranceSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	BeamLimitingDeviceToleranceSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}


	/**
	 * Validates all the attributes in BeamLimitingDeviceToleranceSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try
		{
			if(!contains(0x300A,0x00B8))
				throw new ConditionFailedException("value of conditional Element 300A,00B8 required if 300A,0048 is present") ;
			if(!contains(0x300A,0x004A))
				throw new ConditionFailedException("value of conditional Element 300A,004A required if 300A,0048 is present") ;
		}
		catch( ConditionFailedException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new InvalidItemException(this.getClass().getSimpleName(),ce); 
		}
		return true;
	}

	/**
	 * Sets Type of RT Beam Limiting Device Type.
	 * Type of beam limiting device (collimator).
	 * @param enumRTBeamLimitingDeviceType- Enum value of RT Beam Limiting Device Type.
	 */
	public void setRTBeamLimitingDeviceType(EnumRTBeamLimitingDeviceType enumRTBeamLimitingDeviceType)
	{
		/*Accept the RTBeamLimitingDeviceType in String format of type CS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)	
			objIDataElement = new ImplicitDE(0x300A,0x00B8, enumRTBeamLimitingDeviceType.getValue(),getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x300A,0x00B8,DicomConstants.DCM_DT_CS, enumRTBeamLimitingDeviceType.getValue());

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves RT Beam Limiting Device Type.
	 * @return String - value of RT Beam Limiting Device Type.
	 */
	public String getRTBeamLimitingDeviceType()
	{
		Object objValue = getValue(0x300A,0x00B8);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

	/**
	 * Sets Type of Beam Limiting Device Position Tolerance.
	 * Maximum permitted difference (in mm) between planned and delivered leaf (element) 
	 * or jaw positions for current beam limiting device (collimator).
	 * @param strBeamLimitingDevicePositionTolerance -String value of Beam Limiting Device Position Tolerance.
	 */
	public void setBeamLimitingDevicePositionTolerance(String strBeamLimitingDevicePositionTolerance)
	{
		/*Accept the BeamLimitingDevicePositionTolerance in String format of type DS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)	
			objIDataElement = new ImplicitDE(0x300A,0x004A, strBeamLimitingDevicePositionTolerance,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x300A,0x004A,DicomConstants.DCM_DT_DS, strBeamLimitingDevicePositionTolerance);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves Beam Limiting Device Position Tolerance.
	 * @return String - value of Beam Limiting Device Position Tolerance.
	 */
	public String getBeamLimitingDevicePositionTolerance()
	{
		Object objValue = getValue(0x300A,0x004A);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
}
